/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package rs.ac.bg.fon.silab.jpa.example1.repository;

import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import rs.ac.bg.fon.silab.jpa.example1.domen.BussinessEntity;
import rs.ac.bg.fon.silab.jpa.example1.domen.City;
import rs.ac.bg.fon.silab.jpa.example1.domen.Company;

/**
 *
 * @author FON
 */
public class JPARepository {

    public void saveCity(City city) throws Exception {

        EntityManagerFactory emFactory = Persistence
                .createEntityManagerFactory("JPAExamplePU");
        EntityManager em = emFactory.createEntityManager();

        try {
            City cityFound = em.find(City.class, city.getCode());
            if (cityFound == null) {
                em.getTransaction().begin();
                em.persist(city);
                em.getTransaction().commit();
            } else {
                throw new Exception("City with that code already exists!");
            }

        } catch (Exception e) {
            throw e;
        } finally {
            em.close();
            emFactory.close();
        }

    }

    public void saveOrUpdateCity(City city) {

        EntityManagerFactory emFactory = Persistence
                .createEntityManagerFactory("JPAExamplePU");
        EntityManager em = emFactory.createEntityManager();

        em.getTransaction().begin();

        City cityFound = em.find(City.class, city.getCode());
        if (cityFound == null) {
            em.persist(city);
        } else {
            // em.merge(city);
            cityFound.setName(city.getName());
        }

        em.getTransaction().commit();
        em.close();
        emFactory.close();

    }

    public void saveCompany(Company company) throws Exception {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("JPAExamplePU");
        EntityManager em = emf.createEntityManager();

//        em.persist(company);
        //proveri da li postoji kompanija sa istim ident number
        //Company existingCompany = (Company) em.createQuery("SELECT c FROM Company c WHERE c.identNumber = :identNumber").setParameter("identNumber", company.getIdentNumber()).getSingleResult();
        List<Company> companies = em.createQuery("SELECT c FROM Company c WHERE c.identNumber = :identNumber").setParameter("identNumber", company.getIdentNumber()).getResultList();
        try {
            if (companies.isEmpty()) {
                em.getTransaction().begin();
                Company newCompany = em.merge(company);
                em.getTransaction().commit();
                System.out.println(newCompany);
            } else {
                throw new Exception("Company with that ident number already exists!");
            }
        } catch (Exception e) {
            throw e;
        } finally {
            em.close();
            emf.close();
        }

    }

    public City findCity(Long code) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("JPAExamplePU");
        EntityManager em = emf.createEntityManager();

        City city = em.find(City.class, code);
        System.out.println(city);
        em.close();
        emf.close();
        return city;
    }

    public void updateCompany(Company company) throws Exception {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("JPAExamplePU");
        EntityManager em = emf.createEntityManager();

        Company existingCompany = em.find(Company.class, company.getCompanyID());
        try {
            if (existingCompany != null) {
                em.getTransaction().begin();
                existingCompany = em.merge(company);
                em.getTransaction().commit();
            } else {
                throw new Exception("Company with that ID does not exist!");
            }
        } catch (Exception e) {
            throw e;
        } finally {
            em.close();
            emf.close();
        }

    }
    
    public void saveBussinessEntity(BussinessEntity bussinessEntity){
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("JPAExamplePU");
        EntityManager em = emf.createEntityManager();
        
        em.getTransaction().begin();
        em.persist(bussinessEntity);
        em.getTransaction().commit();
        
        em.close();
        emf.close();
    }
}
