/*
SQLyog Community v12.5.1 (64 bit)
MySQL - 5.7.21-log : Database - njt
*********************************************************************
*/

/*!40101 SET NAMES utf8 */;

/*!40101 SET SQL_MODE=''*/;

/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;
CREATE DATABASE /*!32312 IF NOT EXISTS*/`njt` /*!40100 DEFAULT CHARACTER SET utf8 */;

USE `njt`;

/*Table structure for table `bussinessentity` */

DROP TABLE IF EXISTS `bussinessentity`;

CREATE TABLE `bussinessentity` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT NULL,
  `first_name` varchar(50) DEFAULT NULL,
  `last_name` varchar(50) DEFAULT NULL,
  `type` char(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

/*Data for the table `bussinessentity` */

insert  into `bussinessentity`(`id`,`name`,`first_name`,`last_name`,`type`) values 
(1,NULL,'Zika','Zikic','P');

/*Table structure for table `city` */

DROP TABLE IF EXISTS `city`;

CREATE TABLE `city` (
  `code` bigint(20) unsigned NOT NULL,
  `name` varchar(100) DEFAULT NULL,
  PRIMARY KEY (`code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Data for the table `city` */

insert  into `city`(`code`,`name`) values 
(11000,'Novi Beograd'),
(13000,'Pancevo');

/*Table structure for table `company` */

DROP TABLE IF EXISTS `company`;

CREATE TABLE `company` (
  `companyID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(50) DEFAULT NULL,
  `vat` varchar(9) DEFAULT NULL,
  `ident_number` varchar(8) DEFAULT NULL,
  `address` varchar(250) DEFAULT NULL,
  `code_city_fk` bigint(20) unsigned DEFAULT NULL,
  PRIMARY KEY (`companyID`),
  KEY `code_city_fk` (`code_city_fk`),
  CONSTRAINT `company_ibfk_1` FOREIGN KEY (`code_city_fk`) REFERENCES `city` (`code`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;

/*Data for the table `company` */

insert  into `company`(`companyID`,`name`,`vat`,`ident_number`,`address`,`code_city_fk`) values 
(1,'FON','vat1','ident1','Jove Ilica 154',11000),
(2,'FON','vat1','ident2','Jove Ilica 154',11000),
(3,'FON','vat1','ident3','Jove Ilica 154',11000),
(4,'FON','vat1','ident4','Jove Ilica 154',13000),
(5,'FON','vat1','ident5','Jove Ilica 154',13000),
(7,'FON-7','vat7','ident7','Jove Ilica 154',13000);

/*Table structure for table `contactaddress` */

DROP TABLE IF EXISTS `contactaddress`;

CREATE TABLE `contactaddress` (
  `contact_address_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `value` varchar(100) DEFAULT NULL,
  `contact_address_type` varchar(20) DEFAULT NULL,
  `company_fk` bigint(20) unsigned DEFAULT NULL,
  PRIMARY KEY (`contact_address_ID`),
  KEY `contact_address_company_fk` (`company_fk`),
  CONSTRAINT `contact_address_company_fk` FOREIGN KEY (`company_fk`) REFERENCES `company` (`companyID`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8;

/*Data for the table `contactaddress` */

insert  into `contactaddress`(`contact_address_ID`,`value`,`contact_address_type`,`company_fk`) values 
(9,'fon.bg.ac.rs','WEB_ADDRESS',7),
(10,'neki@email.bg.ac.rs','EMAIL',7);

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
